{ import: reflection }
{ include "send2.h" }

DelegationObject : Object ( next )

DelegationObject _delegate
[
    ^next
]

DelegationObject delegate: anObject
[
    next := anObject
]

DelegationObject insertDelegate: aDelegationObject
[
    aDelegationObject delegate: self _delegate.
    self delegate: aDelegationObject
]

DelegationObject removeDelegate
[
	| del |
	del := self _delegate.
	self delegate: del _delegate.
	del delegate: nil.
]

DelegationObject removeDelegate: aDelegationObject
[
	| cur |
	cur := self.
	[ cur _delegate notNil ] whileTrue: [
		( cur _delegate == aDelegationObject ) ifTrue: [
			cur delegate: aDelegationObject _delegate.
"			aDelegationObject delegate: nil."
			^ cur.
		].
		cur := cur _delegate.
	]
]

" No use of putting DelegationObject here instead of Object, because vtable delegate will be reset anyway..."
Proxy : Object ( next typetag indirecttt )

"reset vtable to get rid of sizeof and debugName"

[
    Proxy := DelegationObject _delegated. 
]

Proxy delegate: anObject
[
    next := anObject
]

Proxy _delegate
[
    ^next
]

Proxy typetag: tag
[
    typetag := tag
]

Proxy indirecttt: flag
[
    indirecttt := flag
]

"
Proxy _receiver: anObject
[
    receiver := anObject
]

Proxy _receiver
[
    ^receiver
]
"
"
Proxy insertDelegate: aProxy
[
    aProxy delegate: self _delegate.
    self delegate: aProxy
]
"

"
Proxy _delegated [
    ^ self _delegated: (next _sizeof)
]

Proxy _delegated: size
[
    | inst proxy |
    inst := next _real_delegated.
    StdOut println: 'next delegated done'.
    StdOut println: (inst _vtable)."
	" for the next few lines, _vtable instead of _real_vtable is fine:
		- _vtable will be found through vtable delegation in next _real_delegated
		- _real_vtable would be found through _delegate delegation in Object (inefficient, + _delegate would need to be set already "
	"ANY object must be capable of answering to _delegate, because otherwise the delegation chain won't be searched"
"	inst _vtable methodAt: #_delegate put: (DelegationObject _vtable methodAt: #_delegate) with: 0."
"    StdOut println: 'delegate put'."
	"need this because next might be an object which was created through this method as well in which case its vtable is all the new inst has
		to do the 'delegate:' call two lines above (for that call the delegation chain can't be searched yet of course)
		(out-of-date: call (now below) now uses this #delegate: method of course)"
"	inst _vtable methodAt: #delegate: put: (DelegationObject _vtable methodAt: #delegate:) with: 0."
	"needed, because inst will delegate to here (self), in which case 'inst _vtable' would result in 'Proxy _vtable' being
	executed, which is 'next _vtable' (i.e. 'here _vtable'), so another 'next _vtable', so the actual parent's _vtable."
"	inst _vtable methodAt: #_vtable put: (Proxy _real_vtable methodAt: #_real_vtable) with: 0."
	"need 'new' in order to allocate memory for slots"
"	inst := inst _vtable _alloc: size." "don't use 'new' itself, because it won't be found yet (delegate is set after this)"
	"set delegate now (would have been erased by the 'new' above"
"    inst delegate: self."
	"remove vtable delegation chain, so now we're relying on _delegate delegation only"
"	inst resetVtableDelegate."

	"attach proxy"
"	proxy := Proxy _newProxy.
	proxy delegate: inst."
	"the proxy IS the object now..."
"    ^proxy.
]"

"
Proxy _sizeof
[
	^(next _sizeof).
]

Proxy _debugName
[
	^(next _debugName).
]
"

"don't call this 'new', because proxied objects might want to use there delegate's 'new'"
Proxy _newProxy
[
	| inst size real_vtable |
	{
		// making this var static somehow would help...
		v_size = (oop)sizeof(struct t_Proxy);

        v_real_vtable = (oop) v_self->_vtable[-1];
	}.
	"inst now does NOT have a separate vtable, so don't put anything in it (will end up in Proxy _vtable)"
	inst := real_vtable _alloc: size.
	^inst.
]

"
Proxy _real_vtable
{
	return (oop) v_stateful_self->_vtable[-1]; // stateful always ok?
}

Proxy _real_vtable_self
{
	return (oop) v_self->_vtable[-1];
}
"

"Make sure a proxy returns its delegate's vtable, so that method additions will occur there."
"This has to be the last addition, because from now on methods will be added to the wrong vtable (Object _vtable)"
"
Proxy _vtable
[
	^(next _vtable).
]
"
[
	Proxy resetVtableDelegate.
]

ProxifiedObject : DelegationObject ( )

"
ProxifiedObject typetag: value
[
    typetag := value
]

ProxifiedObject typetag
[
    ^typetag
]
"

ProxifiedObject _vtable
{
    return (oop) v_stateful_self->_vtable[-1];
}

ProxifiedObject _delegated
[
    " do not use stateful_self at front, because _delegated still uses self to fix delegates "
    ^ self _delegated: (stateful_self _sizeof) 
]

ProxifiedObject _delegated: size
[
    | inst proxy |
    " use stateful_self to bypass proxies "
    inst := stateful_self _real_delegated.
	" for the next few lines, _vtable instead of _real_vtable is fine:
		- _vtable will be found through vtable delegation in next _real_delegated
		- _real_vtable would be found through _delegate delegation in Object (inefficient, + _delegate would need to be set already "
	"ANY object must be capable of answering to _delegate, because otherwise the delegation chain won't be searched"
	inst _vtable methodAt: #_delegate put: (DelegationObject _vtable methodAt: #_delegate) with: 0.
	"need this because next might be an object which was created through this method as well in which case its vtable is all the new inst has
		to do the 'delegate:' call two lines above (for that call the delegation chain can't be searched yet of course)
		(out-of-date: call (now below) now uses this #delegate: method of course)"
	inst _vtable methodAt: #delegate: put: (DelegationObject _vtable methodAt: #delegate:) with: 0.
    " need the following because they use stateful_self, hence they must be defined in the object which you want to be stateful_self "
    inst _vtable methodAt: #_delegated put: (stateful_self _vtable methodAt: #_delegated) with: 0.
    inst _vtable methodAt: #_delegated: put: (stateful_self _vtable methodAt: #_delegated:) with: 0.
	"needed, because inst will delegate to here (self), in which case 'inst _vtable' would result in 'Proxy _vtable' being
	executed, which is 'next _vtable' (i.e. 'here _vtable'), so another 'next _vtable', so the actual parent's _vtable."
	inst _vtable methodAt: #_vtable put: (ProxifiedObject _vtable methodAt: #_vtable) with: 0.
	"need 'new' in order to allocate memory for slots"
	inst := inst _vtable _alloc: size. "don't use 'new' itself, because it won't be found yet (delegate is set after this)"
	"set delegate now (would have been erased by the 'new' above)"
    inst delegate: self.
	"remove vtable delegation chain, so now we're relying on _delegate delegation only"
	inst resetVtableDelegate.

	"attach proxy"
	proxy := Proxy _newProxy.
	proxy delegate: inst.
"    proxy _receiver: inst."
	"the proxy IS the object now..."
    ^proxy.
]


"
ProxifiedObject _special_delegated
[
    | inst proxified |
    inst := next _delegated.
    inst delegate: self.
	
    ""important: inst MUST be capable of answering the _delegate msg!! (if not, endless loop in libid.c)""
	
    inst _vtable methodAt: #_delegate put: (ProxifiedObject _vtable methodAt: #_delegate) with: 0.
    proxified := inst attachProxy.
	inst resetVtableDelegate.
    ^proxified.
]
"
"
ProxifiedObject rattachProxy
[
    | proxy |
    proxy := super _delegated new.
    proxy delegate: self.
    proxy _vtable methodAt: #_delegate put: (ProxifiedObject _vtable methodAt: #_delegate) with: 0.
    proxy _vtable methodAt: #delegate put: (ProxifiedObject _vtable methodAt: #delegate) with: 0.
    proxy _vtable methodAt: #_delegated put: (ProxifiedObject _vtable methodAt: #_special_delegated) with: 0. 
"" don't override _vtable too quickly, or methodAtPut will work on the wrong vtable too! ""
""   proxy _vtable methodAt: #_vtable put: (Proxy _vtable methodAt: #specialVtable) with: 0. ""
	proxy resetVtableDelegate.
    ^proxy.
]
"

[
	| proxy zero |
	proxy := Proxy _newProxy.
    {v_zero = 0;}.
    proxy typetag: zero.
    proxy indirecttt: zero.
	proxy delegate: ProxifiedObject.
"    proxy _receiver: ProxifiedObject."
	ProxifiedObject := proxy.
]

